﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RecursiveMazeMain
{
    public partial class NewMazeStartForm : Form
    {
        private int newRows;
        private int newColumns;

        public int NewRows
        {
            get
            {
                return Convert.ToInt32(NewRowComboBox.Text);
            }
        }

        public int NewColumns
        {
            get
            {
                return Convert.ToInt32(NewColumnComboBox.Text);
            }
        }

        public NewMazeStartForm()
        {
            InitializeComponent();
        }

        //*********************************OkButtonClick**************************
        // This event will be called when the OK button is clicked and will
        // return a dialog result of OK.
        //************************************************************************
        private void NewMazeFormOKButton_Click(object sender, EventArgs e)
        {
            
            DialogResult = DialogResult.OK;
        }//End of NewMazeFormOKClick

        //********************************CancelButtonClick*************************
        // This event will be called when the cancel button is clicked. It will
        // return a dialog result of cancel.
        //**************************************************************************
        private void NewMazeFormCancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }//End of NewMazeFormCancelClick

        //***********************************ValidateRowData**************************
        // This validation event will be called whenever the row text box loses focus.
        // It will check and make sure that the row value is between 2 and 7.
        //****************************************************************************
        private void ValidateRowData(object sender, CancelEventArgs e)
        {
            if (Convert.ToInt32(NewRowComboBox.Text) < 2 || Convert.ToInt32(NewRowComboBox.Text) > 7)
            {
                MessageBox.Show("The rows must be beween 2 and 7.");
                NewRowComboBox.Focus();
            }
            else
            {
                newRows = Convert.ToInt32(NewRowComboBox.Text);
            }
        }//End of ValidateRowData

        //***********************************ValidatecolumnData**************************
        // This validation event will be called whenever the row text box loses focus.
        // It will check and make sure that the column value is between 2 and 7.
        //****************************************************************************
        private void ValidateColumnData(object sender, CancelEventArgs e)
        {
            if (Convert.ToInt32(NewColumnComboBox.Text) < 2 || Convert.ToInt32(NewColumnComboBox.Text) > 7)
            {
                MessageBox.Show("The columns must be beween 2 and 7.");
                NewColumnComboBox.Focus();
            }
            else
            {
                newColumns = Convert.ToInt32(NewColumnComboBox.Text);
            }
        }//End of ValidateColumnData
    }
}
