﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.IO.Pipes;
using System.Threading;

//Tutorial from www.dijksterhuis.org/using-named-pipes-in-c-windows/

namespace ConnectionTest
{

    public interface TestConnector
    {
        void StartServer();
        void StartClient();
        //void TestSend();
    };
    public class ManagedClass:TestConnector
    {
        public void StartServer()
        {
            using (System.IO.Pipes.NamedPipeServerStream pipeStream = new NamedPipeServerStream("TestPipe"))
            {
                Console.WriteLine("[Server] Pipe Created {0}", pipeStream.GetHashCode());
                Console.WriteLine("Waiting for client connection");

                //wait for connection using a loop
                pipeStream.WaitForConnection();
                
                //while (pipeStream.IsConnected == false)
                //{
                //    //busy loop
                    
                //}
                //if here then connected
                Console.WriteLine("[Server] Pipe Connection Established");

                using (StreamReader sr = new StreamReader(pipeStream))
                {
                    string temp;
                    //read line from pipe and print with current time
                    while ((temp = sr.ReadLine()) != null)
                    {
                        Console.WriteLine("{0}: {1}", DateTime.Now, temp);
                    }
                }

                pipeStream.Close();
            }
            
        }//End of StartServer

        public void StartClient()
        {
            //Start client only after server has created the pipe
            // ManualResetEvent SyncClientServer = (ManualResetEvent)obj;

            using (NamedPipeClientStream pipeStream = new NamedPipeClientStream("TestPipe"))
            {
                //connect to server
                pipeStream.Connect();

                Console.WriteLine("[Client] Pipe Connection Established");
                using (StreamWriter sw = new StreamWriter(pipeStream))
                {
                    sw.AutoFlush = true;
                    string temp;
                    Console.WriteLine("Please type a message and press [enter], or type quit to exit the program.");
                    while ((temp = Console.ReadLine()) != null)
                    {
                        if (temp == "quit")
                        {
                            break;
                        }
                        sw.WriteLine(temp);
                    }
                }

                pipeStream.Close();
            }
            
        }//End of StartClient

    }
}
